
/* JSVMStruct.java.

	$Log: JSVMStruct.java,v $
	Revision 1.1  2006/04/26 13:19:18  richard
	Added the file.
	
 
 */


package jsvmstruct;

import java.lang.reflect.*;

class JSVMStruct {
	
	static {
		System.loadLibrary("JSVMStruct");
	}
	
	static native int callLearnMain(LearningProblem problem, String[] argv);
	
	public static void main(String[] argv) {
		
		if(argv.length < 2) {
			System.err.println("First argument must be -learn or -predict.");
			System.err.println("Second argument must be the class name of the learning problem.");
			System.exit(1);
		}
		
		LearningProblem problem = null;
		try {
			Class cl = Class.forName(argv[1]);
			Constructor con = cl.getConstructor();
			problem = (LearningProblem) con.newInstance();
		} catch(Exception e) {
			e.printStackTrace();
			System.exit(1);
		}
		
		String[] new_argv = new String[argv.length - 2];
		System.arraycopy(argv, 2, new_argv, 0, new_argv.length);
		
		int status = -1;
		
		if(argv[0].equals("-learn")) {
			status = callLearnMain(problem, new_argv);			
		} else if(argv[0].equals("-predict")) {
			
			//status = callPredictMain(problem, new_argv);
			try {
				problem.test(new_argv);
			} catch(Throwable t) {
				t.printStackTrace();
			}
			status = 0;
			
		} else {
			System.err.println("First argument must be -learn or -predict.");
			System.exit(1);
		}
		
		System.exit(status);
		
	}
	
}
